#pragma option -l; // Disable header inclusion in listing
/*
        MPC Code Development System
        Header file for PIC16C54        V1.10

                        16C54.H

        (c) Copyright 1995   Byte Craft Limited
        421 King St.N., Waterloo, ON, Canada, N2J 4E4

        Sherif Abdel-Kader
*/

// 12-bit core
#pragma has PIC12;

// Reset vector
#pragma vector __RESET @ 0x1ff;

// ROM and RAM sizes/starting address
#pragma option +l;  // Enable header to show branch islands
#define MAXROM 512
#pragma memory ROM [MAXROM] @ 0x00;
#pragma memory RAM [24]     @ 0x08;  // Reserve byte for __WImage
#pragma option -l;  // Disable rest of header in listing


// Working (W) register
registerw  WREG;

// Special-purpose registers
#pragma portrw INDF      @ 0x00;
#pragma portrw RTCC      @ 0x01;
#pragma portrw PC        @ 0x02;
#pragma portrw STATUS    @ 0x03;
#pragma portrw FSR       @ 0x04;
#pragma portrw PORTA     @ 0x05;
#pragma portrw PORTB     @ 0x06;

// __WImage for returning variables from functions
char __WImage @0x07;

// STATUS register bits
#define  C   0
#define  DC  1
#define  Z   2
#define  PD  3
#define  TO  4
#define  PA0 5
#define  PA1 6
#define  PA2 7

// OPTION register bits
#define  PS0 0
#define  PS1 1
#define  PS2 2
#define  PSA 3
#define  RTE 4
#define  RTS 5

// TRIS macro for accessing TRISx registers
#define __TRIS(value,portid) #asm ( dw 0xC00+value,portid )

// Macros for accessing OPTION register
#define OPTION() #asm ( dw 0x02 )             // OPTION instruction
#define __OPTION(value) WREG=value; OPTION()  // Load W, then OPTION

// Enable listing for user program
#pragma option +l;

