/*
   These routines may be adapted for any purpose when
   used with the MPC Code Development system.  No
   warranty is implied or given as to their usability
   for any purpose.

        (c) Copyright 1995

        Byte Craft Limited
        Waterloo, Ontario
        Canada N2J 4E4
        (519) 888-6911

        Sherif Abdel-Kader
*/

// Example on the defined() function
//
// This demonstrates how the defined()
// function can be used to arbitrarily
// compile certain portions of the code.
//
// Note that only the function prototype
// need be commented out so as not to
// include it.
//

// If compiling this program using other
// Byte Craft Compilers. You can identify
// the MPC compiler by checking for __MPC

// Compile this code only if using MPC
#if defined(__MPC)

// Compile program for any of thel 12-
// 14- and 16-bit PICs.
//#include <16C54.h>
//#include <16C64.h>
#include <17C42.h>

//#define VAR1  1
#define VAR2  2

//void func1(void);
void func2(void);

void main() {
//int i;
int j;
unsigned int x;

// defined() used with variables
#if defined(i)
  i = 5;
#elif defined(j)
  j = 5;
#endif

// defined() used with macros
#if defined(VAR1)
  x = VAR1;
#elif defined(VAR2)
  x = VAR2;
#endif

// defined() used with functions
#if defined(func1)
  func1();
#elif defined (func2)
  func2();
#endif

// Setting the direction for
// PORTB. Code varies depending
// on architecture.
//
#if defined(__PIC12)
  __TRISB(0xFF,PORTB);
#elif defined(__PIC14)
  TRISB = 0xFF;
#elif defined(__PIC16)
  DDRB = 0xFF;
#endif
  x = PORTB;
}

void func1(void) {
  int y = 3;
  y++;
}

void func2(void) {
  int z = 2;
  z--;
}

#endif
