/*
   These routines may be adapted for any purpose when
   used with the MPC Code Development system.  No
   warranty is implied or given as to their usability
   for any purpose.

        (c) Copyright 1995

        Byte Craft Limited
        Waterloo, Ontario
        Canada N2J 4E4
        (519) 888-6911

        Sherif Abdel-Kader
*/
// This is an example of parameter passing
// through the W and FSR (index) registers
// without using the #pragma regw  and
// #pragma regix. It uses the predefined
// variable WREG to access the W register.
//
// Notes:
//
// 1. Before calling the function, make sure you
//    assign FSR first and then W in order not to
//    destroy the contents of W.
// 2. Inside the function, read W first, then FSR.

#include <16C84.h>

void f1();

void main() {

 FSR = 0x05;
 WREG = 0x03;
 f1();
}

void f1() {
  TRISB = 0x00;   // PORTB in o/p mode
  PORTB = WREG;
  TRISA = 0x00;   // PORTA in o/p mode
  PORTA = FSR;
}
